
#include "..\C-Engine\CEngine.hpp"

#include "Script_Control.hpp"
#include "GUI.hpp"
#include "IA_Bomber.hpp"
#include "IA_Whispy.hpp"

int Niveau1()
{

    #include "Sprite.hpp" // Inclusion des sprites.


    //*****************Creation des objects******************

    Object * Kirby = new Object;
    Kirby->GetTransform()->SetXY(8, 32);
    Kirby->GetRender()->SetRender(A_Kirby , 13);

    Control * Kirby_Script = new Control;
    Kirby->AffectScript(Kirby_Script);

    Object * Aspiration = new Object;
    Aspiration->GetRender()->SetRender(A_Aspiration);
    Aspiration->AffectTag("Aspiration");

    SAspi * Aspiration_Script = new SAspi;
    Aspiration->AffectScript(Aspiration_Script);

    Script_GUI * Game_GUI = new Script_GUI;
    Kirby_Script->Initialisation( A_Star , A_Soufle , Aspiration , Game_GUI );
    Kirby_Script->AOurs = A_Ours;
    Kirby_Script->APiaf = A_Piaf;
    Kirby_Script->AChamp = A_Champ;
    Kirby_Script->ABaby = A_Baby;
    Kirby_Script->AGhost = A_Ghost;
    Kirby_Script->AOupa = A_Oupa;

    Object * Bomber = new Object;
    Bomber->GetTransform()->SetXY(120, 16);
    Bomber->GetRender()->SetRender(A_Bomber , 3);
    Bomber->AddRigidBody();
    Bomber->GetRigidBody()->SetMass(2);
    Bomber->AffectTag("Boss");

    Mob_Bomber * Bomber_Script = new Mob_Bomber;
    Bomber->AffectScript(Bomber_Script);
    Bomber_Script->A_Bomb = A_Bomb;

    Object * Whispy = new Object;
    Whispy->GetTransform()->SetXY(104,32);
    Whispy->GetRender()->SetRender(A_Wood , 3);
    Whispy->AffectTag("Boss");

    Mob_Whispy * Whispy_Script = new Mob_Whispy;
    Whispy->AffectScript(Whispy_Script);
    Whispy_Script->A_Apple = A_Apple;
    Whispy_Script->A_Souffle = A_Soufle;
    Whispy_Script->A_FS = A_FinalStar;

    Object * Pill1 = new Object;
    Pill1->GetTransform()->SetXY(0,0);
    Pill1->GetRender()->SetRender(A_Pill);
    Pill1->AffectTag("Pill");

    Object * Pill2 = new Object;
    Pill2->GetTransform()->SetXY(0,0);
    Pill2->GetRender()->SetRender(A_Pill);
    Pill2->AffectTag("Pill");

    Object * MHealth1 = new Object;
    MHealth1->GetTransform()->SetXY(0,0);
    MHealth1->GetRender()->SetRender(A_MHealth);
    MHealth1->AffectTag("MHealth");


    //***********Creation de la map***************

    Level * L_GreenGreen1 = new Level;
    L_GreenGreen1->SetMap(GreenGreenTileset , GreenGreen1 , GreenGreenProp , 16 , 16 , 90 , 8);

    Level * L_GreenGreen2 = new Level;
    L_GreenGreen2->SetMap(GreenGreenTileset , GreenGreen2 , GreenGreenProp , 16 , 16 , 82 , 8);

    Level * L_GreenGreen3 = new Level;
    L_GreenGreen3->SetMap(GreenGreenTileset , GreenGreen3 , GreenGreenProp , 16 , 16 , 16 , 40);

    Level * L_GreenGreen4 = new Level;
    L_GreenGreen4->SetMap(GreenGreenTileset , GreenGreen4 , GreenGreenProp , 16 , 16 , 10 , 24);

    Level * L_GreenGreen5 = new Level;
    L_GreenGreen5->SetMap(GreenGreenTileset , GreenGreen5 , GreenGreenProp , 16 , 16 , 15 , 8);

    Level * GreenGreenWorld[] = { L_GreenGreen1 , L_GreenGreen2 , L_GreenGreen3 , L_GreenGreen4 , L_GreenGreen5};

    Trigger * Trigger1 = new Trigger;   Trigger1->CreateTrigger( 688  , 32 , 16 , 25 );     Trigger1->SetDestination( 112 , 48 , 4 , "Kirby");
    Trigger * Trigger2 = new Trigger;   Trigger2->CreateTrigger( 112  , 48 , 16 , 25 );     Trigger2->SetDestination( 688 , 32 , 0 , "Kirby");
    Trigger * Trigger3 = new Trigger;   Trigger3->CreateTrigger( 1200 , 16 , 16 , 25 );     Trigger3->SetDestination( 96 , 32 , 2  , "Kirby");
    Trigger * Trigger4 = new Trigger;   Trigger4->CreateTrigger( 128 , 544 , 16 , 25 );     Trigger4->SetDestination( 16 , 336 , 3 , "Kirby");
    Trigger * Trigger5 = new Trigger;   Trigger5->CreateTrigger( 1250 , 68 , 16 , 16 );     Trigger5->SetDestination( 8 , 16 , 1   , "Kirby");  Trigger5->GetRender()->SetRender(A_Star);

    //**************Assignation des objects************

    Engine Game;

    Game.SetLevel(GreenGreenWorld,5);

    Game.AddObject(Trigger1,0);
    Game.AddObject(Trigger2,4);
    Game.AddObject(Trigger3,1);
    Game.AddObject(Trigger4,2);
    Game.AddObject(Trigger5,0);

    Game.SetCurrentLevel(0);

    Game.AddObject(Kirby,0);
    Game.AddObject(Bomber,1);
    Game.AddObject(Whispy,3);

    Game.SetCurrentLevel(0);

    Game.AffectGui(Game_GUI);

    Game.StartGame();

    return 1;

}

int SelectLevel()
{
    const unsigned char S_level[]={0x30, 0xf, 0xf0, 0xc, 0x0, 0x0, 0x0, 0x0, 0x30, 0xf, 0xf0, 0xc, 0x0, 0x0, 0x0, 0x0, 0x48, 0x70, 0xe, 0x12, 0x0, 0x0, 0x0, 0x0, 0x48, 0x70, 0xe, 0x12, 0x0, 0x0, 0x0, 0x0, 0x85, 0x80, 0x1, 0xa1, 0x0, 0x0, 0x0, 0x0, 0x85, 0x80, 0x1, 0xa1, 0x0, 0x0, 0x0, 0x0, 0x86, 0xf, 0xf0, 0x61, 0x0, 0x0, 0x0, 0x0, 0x86, 0xf, 0xf0, 0x61, 0x0, 0x0, 0x0, 0x0, 0x84, 0x60, 0x6, 0x21, 0x0, 0x0, 0x0, 0x0, 0x84, 0x60, 0x6, 0x21, 0x0, 0xff, 0xff, 0x80, 0x85, 0x80, 0x1, 0xa1, 0x0, 0x0, 0x0, 0x0, 0x85, 0x80, 0x1, 0xa1, 0x1, 0x0, 0x0, 0x40, 0xce, 0x1, 0x0, 0x73, 0x0, 0x0, 0x0, 0x0, 0xce, 0x0, 0x0, 0x73, 0x2, 0x0, 0x0, 0x20, 0xbc, 0x1, 0x0, 0x1d, 0x0, 0x0, 0x0, 0x0, 0xbc, 0x0, 0x0, 0x1d, 0x2, 0x62, 0x33, 0x20, 0x9c, 0x9, 0x20, 0x33, 0x0, 0x0, 0x0, 0x0, 0x98, 0x1f, 0xf0, 0x13, 0x2, 0x55, 0x44, 0x20, 0x9e, 0x9, 0xf1, 0x73, 0x0, 0x0, 0x0, 0x0, 0x98, 0x60, 0xc, 0x93, 0x2, 0x65, 0x77, 0x20, 0x8f, 0x16, 0x9e, 0x51, 0x0, 0x0, 0x0, 0x0, 0x88, 0x80, 0x3, 0x51, 0x2, 0x55, 0x11, 0x20, 0x89, 0xa0, 0x7, 0x91, 0x0, 0x0, 0x0, 0x0, 0x89, 0x0, 0x1, 0x51, 0x2, 0x62, 0x66, 0x20, 0x98, 0xe0, 0x7, 0x13, 0x0, 0x3, 0x6, 0xc, 0x99, 0x0, 0x0, 0xd3, 0x2, 0x0, 0x0, 0x20, 0x98, 0x23, 0x24, 0x13, 0x0, 0x7, 0x8f, 0x1e, 0x9a, 0x0, 0x0, 0xd3, 0x1, 0x0, 0x0, 0x40, 0x88, 0x23, 0x24, 0x11, 0x0, 0x7, 0x8f, 0x1e, 0x8a, 0x0, 0x6, 0x91, 0x0, 0xff, 0xff, 0x80, 0x88, 0x23, 0x24, 0x11, 0x0, 0x3, 0x6, 0xc, 0x8a, 0x60, 0x9, 0xd1, 0x0, 0x1, 0x80, 0x0, 0x98, 0x23, 0x24, 0x13, 0x0, 0x0, 0x0, 0x0, 0x9b, 0x6c, 0x2, 0xd3, 0x0, 0x0, 0x0, 0x0, 0x98, 0x21, 0x4, 0x13, 0x0, 0x0, 0x0, 0x0, 0x9a, 0x60, 0x2, 0xd3, 0x0, 0x0, 0x0, 0x0, 0x88, 0x20, 0x1e, 0x11, 0x0, 0x0, 0x0, 0x0, 0x8a, 0x0, 0x9, 0x91, 0x0, 0x0, 0x0, 0x0, 0x88, 0x20, 0x21, 0x11, 0x0, 0x3, 0x0, 0x0, 0x8a, 0x0, 0x7, 0xd1, 0x0, 0x1, 0x80, 0x0, 0x98, 0x20, 0x1e, 0x13, 0x0, 0x7, 0x80, 0x0, 0x99, 0x0, 0x0, 0xd3, 0x0, 0x3, 0xc0, 0x0, 0x98, 0x20, 0x4, 0x13, 0x0, 0x7, 0x80, 0x0, 0x99, 0x0, 0x1, 0x53, 0x0, 0x3, 0xc0, 0x0, 0x88, 0x20, 0xc4, 0x11, 0x0, 0x3, 0x0, 0x0, 0x88, 0x80, 0x1, 0x51, 0x0, 0x1, 0x80, 0x0, 0x88, 0x20, 0xc4, 0x11, 0x0, 0x0, 0x0, 0x0, 0x88, 0x40, 0x2, 0x91, 0x0, 0x0, 0x0, 0x0, 0x98, 0x20, 0xc4, 0x13, 0x0, 0x0, 0x0, 0x0, 0x98, 0x30, 0x1c, 0x13, 0x0, 0x0, 0x0, 0x0, 0x98, 0x20, 0x4, 0x13, 0x0, 0x0, 0x0, 0x0, 0x98, 0xe, 0xf8, 0x13, 0x0, 0x0, 0x0, 0x0, 0x88, 0x20, 0x4, 0x11, 0x0, 0x3, 0x0, 0x0, 0x88, 0x11, 0x5c, 0x11, 0x0, 0x1, 0x80, 0x0, 0x88, 0x20, 0x4, 0x11, 0x0, 0x7, 0x80, 0x0, 0x88, 0x11, 0xbc, 0x11, 0x0, 0x3, 0xc0, 0x0, 0x98, 0x40, 0x2, 0x13, 0x0, 0x7, 0x80, 0x0, 0x98, 0x11, 0xb8, 0x13, 0x0, 0x3, 0xc0, 0x0, 0x98, 0x80, 0x1, 0x13, 0x0, 0x3, 0x0, 0x0, 0x98, 0x11, 0xb8, 0x13, 0x0, 0x1, 0x80, 0x0, 0x88, 0x91, 0x89, 0x11, 0x0, 0x0, 0x0, 0x0, 0x88, 0xb, 0x60, 0x11, 0x0, 0x0, 0x0, 0x0, 0x88, 0x6e, 0x76, 0x11, 0x0, 0x0, 0x0, 0x0, 0x88, 0x6, 0x0, 0x11, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x30, 0xf, 0xf0, 0xc, 0x0, 0x0, 0x0, 0x0, 0x30, 0xf, 0xf0, 0xc, 0x0, 0x0, 0x0, 0x0, 0x48, 0x70, 0xe, 0x12, 0x0, 0x0, 0x0, 0x0, 0x48, 0x70, 0xe, 0x12, 0x0, 0x0, 0x0, 0x0, 0x85, 0x80, 0x1, 0xa1, 0x0, 0x0, 0x0, 0x0, 0x85, 0x80, 0x1, 0xa1, 0x0, 0x3, 0x0, 0x0, 0x86, 0xf, 0xf0, 0x61, 0x0, 0x0, 0x0, 0x0, 0x86, 0xf, 0xf0, 0x61, 0x0, 0x7, 0x80, 0x0, 0x84, 0x60, 0x6, 0x21, 0x0, 0x6, 0x0, 0x0, 0x84, 0x60, 0x6, 0x21, 0x0, 0x7, 0x80, 0x0, 0x85, 0x80, 0x1, 0xa1, 0x0, 0xf, 0x0, 0x0, 0x85, 0x80, 0x1, 0xa1, 0x0, 0x3, 0x0, 0x0, 0xce, 0x0, 0x0, 0x73, 0x0, 0xf, 0x0, 0x0, 0xce, 0x0, 0x0, 0x73, 0x0, 0x0, 0x0, 0x0, 0xbc, 0x0, 0x0, 0x1d, 0x0, 0x6, 0x0, 0x0, 0xbc, 0x0, 0x0, 0x1d, 0x0, 0x0, 0x0, 0x0, 0x98, 0x60, 0x0, 0x13, 0x0, 0x0, 0x0, 0x0, 0x98, 0x0, 0x0, 0x13, 0x0, 0x0, 0x0, 0x0, 0x98, 0x9f, 0x30, 0x13, 0x0, 0x0, 0x0, 0x0, 0x98, 0x0, 0x0, 0x13, 0x0, 0x3, 0x0, 0x0, 0x89, 0xa1, 0xc8, 0x11, 0x0, 0x0, 0x0, 0x0, 0x88, 0x10, 0x0, 0x11, 0x0, 0x7, 0x80, 0x0, 0x8a, 0x40, 0x28, 0x11, 0x0, 0x6, 0x0, 0x0, 0x88, 0xf, 0x20, 0x11, 0x0, 0x7, 0x80, 0x0, 0x9a, 0x80, 0x28, 0x13, 0x0, 0xf, 0x0, 0x0, 0x98, 0x11, 0xc0, 0x13, 0x0, 0x3, 0x0, 0x0, 0x99, 0x0, 0x10, 0x13, 0x0, 0xf, 0x0, 0x0, 0x98, 0xe0, 0x3c, 0x13, 0x0, 0x0, 0x0, 0x0, 0x8a, 0x1b, 0x7c, 0xd1, 0x0, 0x6, 0x0, 0x0, 0x89, 0xa0, 0x16, 0x11, 0x0, 0x0, 0x0, 0x0, 0x8a, 0x1b, 0x83, 0x31, 0x0, 0x0, 0x0, 0x0, 0x8a, 0x0, 0x2, 0x11, 0x0, 0x0, 0x0, 0x0, 0x9a, 0x80, 0x0, 0xb3, 0x0, 0x0, 0x0, 0x0, 0x9a, 0xf, 0x1, 0x13, 0x0, 0x3, 0x6, 0xc, 0x9b, 0x2, 0x0, 0xb3, 0x0, 0x0, 0x0, 0x0, 0x9a, 0x10, 0x81, 0x13, 0x0, 0x7, 0x8f, 0x1e, 0x88, 0x86, 0x0, 0x71, 0x0, 0x6, 0xc, 0x18, 0x8a, 0x3e, 0x41, 0x31, 0x0, 0x7, 0x8f, 0x1e, 0x8b, 0x88, 0x6c, 0x51, 0x0, 0xf, 0x1e, 0x3c, 0x89, 0x27, 0x41, 0x71, 0x0, 0x3, 0x6, 0xc, 0x9c, 0x68, 0x6c, 0x53, 0x0, 0xf, 0x1e, 0x3c, 0x9a, 0x27, 0x40, 0xd3, 0x0, 0x0, 0x0, 0x0, 0x9c, 0x5a, 0x0, 0x53, 0x0, 0x6, 0xc, 0x18, 0x9a, 0x3d, 0x40, 0x53, 0x0, 0x0, 0x0, 0x0, 0x8b, 0x8c, 0x0, 0x51, 0x0, 0x0, 0x0, 0x0, 0x8a, 0x19, 0x80, 0x51, 0x0, 0x0, 0x0, 0x0, 0x88, 0x2, 0x0, 0x91, 0x0, 0x0, 0x0, 0x0, 0x8a, 0xf, 0x0, 0x91, 0x0, 0x0, 0x0, 0x0, 0x98, 0xe, 0x0, 0x93, 0x0, 0x0, 0x0, 0x0, 0x99, 0x0, 0x3, 0x13, 0x0, 0x0, 0x0, 0x0, 0x98, 0x11, 0x83, 0x13, 0x0, 0x0, 0x0, 0x0, 0x99, 0x40, 0x16, 0x13, 0x0, 0x0, 0x0, 0x0, 0x88, 0x11, 0x7d, 0x11, 0x0, 0x0, 0x0, 0x0, 0x88, 0xe0, 0x38, 0x11, 0x0, 0x0, 0x0, 0x0, 0x88, 0xe, 0x8, 0x91, 0x0, 0x0, 0x0, 0x0, 0x88, 0x11, 0x60, 0x11, 0x0, 0x0, 0x0, 0x0, 0x98, 0x0, 0x4, 0x93, 0x0, 0x0, 0x0, 0x0, 0x98, 0xf, 0xc0, 0x13, 0x0, 0x0, 0x0, 0x0, 0x98, 0x0, 0x3, 0x13, 0x0, 0x0, 0x0, 0x0, 0x98, 0x8, 0x0, 0x13, 0x0, 0x0, 0x0, 0x0, 0x88, 0x0, 0x0, 0x11, 0x0, 0x0, 0x0, 0x0, 0x88, 0x0, 0x0, 0x11, 0x0, 0x0, 0x0, 0x0, 0x88, 0x0, 0x0, 0x11, 0x0, 0x0, 0x0, 0x0, 0x88, 0x0, 0x0, 0x11, };


    bool end = false;
    int display = 15;

    int choix = 1;

    while(end == false)
    {
        input_update();

        if(input_trigger(K_EXE))end = true;

        ML_clear_vram();

        ML_bmp_or_cl(S_level,0,0,128,64);

        if(display < 0)
        {
            switch(choix)
            {
                case 1: ML_rectangle(0,0,31,31,1,ML_WHITE,ML_WHITE); break;
                case 2: ML_rectangle(32,32,63,63,1,ML_WHITE,ML_WHITE); break;
                case 3: ML_rectangle(64,0,95,31,1,ML_WHITE,ML_WHITE); break;
                case 4: ML_rectangle(96,32,128,64,1,ML_WHITE,ML_WHITE); break;
                default:break;
            }

            if(display < -15)display = 15;
        }

        display --;

        ML_rectangle(0,32,31,64,1,ML_WHITE,ML_WHITE);
        ML_rectangle(32,0,63,31,1,ML_WHITE,ML_WHITE);
        ML_rectangle(64,32,95,64,1,ML_WHITE,ML_WHITE);
        ML_rectangle(109,15,115,30,1,ML_WHITE,ML_WHITE);

        ML_display_vram();

        Sleep(25);
    }

    for(int i = 0 ; i < 190 ; i ++)
        {
            ML_line(-1,i,i,-1,ML_BLACK);
            ML_display_vram();
            Sleep(3);
        }

    ML_clear_vram();

    return choix;

}

int Menu()
{
    const unsigned char Menu[]={0x0, 0x0, 0x0, 0x0, 0x0, 0x7, 0x0, 0x0, 0x0, 0xe0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x1, 0x0, 0x0, 0x0, 0x0, 0x0, 0x18, 0x0, 0x0, 0x0, 0x18, 0x0, 0x0, 0x0, 0x0, 0x0, 0x1, 0x0, 0x0, 0x0, 0x0, 0x0, 0x20, 0x0, 0x0, 0x0, 0x4, 0x0, 0x0, 0x0, 0x0, 0x0, 0x1, 0x0, 0x0, 0x0, 0x0, 0x0, 0xc0, 0x0, 0x0, 0x0, 0x3, 0x0, 0x0, 0x0, 0x0, 0x0, 0x1, 0x0, 0x0, 0x0, 0x0, 0x1, 0x0, 0x0, 0x0, 0x0, 0x0, 0x80, 0x0, 0x0, 0x0, 0x0, 0x1, 0x0, 0x0, 0x0, 0x7f, 0x82, 0x0, 0x0, 0x0, 0x0, 0x0, 0x40, 0x0, 0x0, 0x0, 0x0, 0x1, 0x0, 0x0, 0x1, 0x80, 0x64, 0x0, 0x0, 0x0, 0x0, 0x0, 0x20, 0x0, 0x0, 0x0, 0x0, 0x1, 0x0, 0x0, 0x2, 0x0, 0x18, 0x0, 0x0, 0x0, 0x0, 0x0, 0x10, 0x0, 0x0, 0x0, 0x0, 0x1, 0x0, 0x0, 0x4, 0x0, 0x10, 0x0, 0x0, 0x0, 0x0, 0x0, 0x8, 0x0, 0x0, 0x0, 0x0, 0x1, 0x0, 0x0, 0x4, 0x0, 0x20, 0x0, 0x0, 0x0, 0x0, 0x0, 0x4, 0x0, 0x0, 0x0, 0x0, 0x1, 0x0, 0x0, 0x38, 0x0, 0x40, 0x0, 0x0, 0x0, 0x0, 0x0, 0x2, 0x0, 0x0, 0x0, 0x0, 0x1, 0x0, 0x0, 0xc0, 0x0, 0x40, 0x0, 0x0, 0x0, 0x0, 0x0, 0x2, 0x0, 0x0, 0x0, 0x0, 0x1, 0x0, 0x1, 0x0, 0x0, 0x80, 0x0, 0x0, 0x0, 0x0, 0x0, 0x1, 0x0, 0x0, 0x0, 0x0, 0x1, 0x0, 0x2, 0x0, 0x1, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x80, 0x0, 0x0, 0x0, 0x1, 0x0, 0x2, 0x0, 0x1, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x80, 0x0, 0x0, 0x0, 0x1, 0x0, 0x4, 0x0, 0x2, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x40, 0x0, 0x0, 0x0, 0x1, 0x0, 0x4, 0x0, 0x2, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x40, 0x0, 0x0, 0x0, 0x1, 0x0, 0x4, 0x0, 0x2, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x40, 0x0, 0x0, 0x0, 0x1, 0x0, 0x3, 0x0, 0x4, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x20, 0x0, 0x0, 0x0, 0x1, 0x0, 0x0, 0xc0, 0x4, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x20, 0x0, 0x0, 0x0, 0x1, 0x0, 0x0, 0x20, 0x4, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x20, 0x0, 0x0, 0x0, 0x1, 0x0, 0x0, 0x18, 0x8, 0x0, 0x0, 0x0, 0x0, 0x0, 0xf, 0xf0, 0x10, 0x0, 0x0, 0x0, 0x1, 0x0, 0x0, 0x4, 0x8, 0x0, 0x0, 0x0, 0x0, 0x0, 0x10, 0x8, 0x10, 0x0, 0x0, 0x0, 0x1, 0x0, 0x0, 0x2, 0x8, 0x0, 0x0, 0x0, 0x0, 0x0, 0x20, 0x4, 0x10, 0x0, 0x0, 0x0, 0x1, 0x0, 0x0, 0x1, 0x88, 0x0, 0x0, 0x0, 0x0, 0x0, 0x43, 0xc2, 0x10, 0x0, 0x0, 0x0, 0x1, 0x0, 0x0, 0x0, 0xf8, 0x0, 0x0, 0x0, 0x0, 0x0, 0x8c, 0x31, 0x10, 0x0, 0x0, 0x0, 0x1, 0x0, 0x0, 0x0, 0x38, 0x0, 0x0, 0x0, 0x0, 0x0, 0x88, 0x11, 0x10, 0x0, 0x0, 0x0, 0x1, 0x0, 0x0, 0x0, 0x8, 0x0, 0x0, 0x0, 0x0, 0x0, 0x90, 0x9, 0x10, 0x0, 0x0, 0x0, 0x1, 0x0, 0x0, 0x0, 0x8, 0x0, 0x0, 0x0, 0x0, 0x0, 0x90, 0x9, 0x10, 0x0, 0x0, 0x0, 0x1, 0x0, 0x0, 0x0, 0x8, 0x0, 0x0, 0x0, 0x0, 0x0, 0x90, 0x9, 0x10, 0x0, 0x0, 0x0, 0x1, 0x0, 0x0, 0x0, 0x8, 0x0, 0x0, 0x0, 0x0, 0x0, 0x90, 0x9, 0x10, 0x0, 0x0, 0x0, 0x1, 0x0, 0x0, 0x0, 0x8, 0x0, 0x0, 0x0, 0x0, 0x0, 0x90, 0x9, 0x10, 0x0, 0x0, 0x0, 0x1, 0x0, 0x0, 0x0, 0x8, 0x0, 0x0, 0x0, 0x0, 0x0, 0x90, 0x9, 0x10, 0x0, 0x0, 0x0, 0x1, 0x0, 0x0, 0x0, 0x8, 0x0, 0x0, 0x0, 0x0, 0x0, 0x90, 0x9, 0x10, 0x0, 0x0, 0x0, 0x1, 0x0, 0x0, 0x0, 0x8, 0x0, 0x0, 0x0, 0x0, 0x0, 0x90, 0x9, 0x10, 0x0, 0x0, 0x0, 0x1, 0x0, 0x0, 0x0, 0x8, 0x0, 0x0, 0x0, 0x0, 0x0, 0x90, 0x9, 0x10, 0x0, 0x0, 0x0, 0x1, 0x0, 0x0, 0x0, 0x8, 0x0, 0x0, 0x0, 0x0, 0x0, 0x90, 0x9, 0xff, 0x0, 0x0, 0x0, 0x1, 0x0, 0x0, 0x0, 0x8, 0x0, 0x0, 0x0, 0x0, 0x0, 0x90, 0x9, 0x0, 0x80, 0x0, 0x0, 0x1, 0x0, 0x0, 0x0, 0x8, 0x0, 0x0, 0x0, 0x0, 0x0, 0x90, 0x9, 0x0, 0x40, 0x0, 0x0, 0x1, 0x0, 0x0, 0x0, 0x8, 0x0, 0x0, 0x0, 0x0, 0x0, 0x90, 0x9, 0xfc, 0x20, 0x0, 0x0, 0x1, 0x0, 0x0, 0x0, 0x8, 0x0, 0x0, 0x0, 0x0, 0x0, 0x90, 0x9, 0x3, 0x10, 0x0, 0x0, 0x1, 0x0, 0x0, 0x0, 0x8, 0x0, 0x0, 0x0, 0x0, 0x0, 0x90, 0x9, 0x1, 0x10, 0x0, 0x0, 0x1, 0x0, 0x0, 0x0, 0x8, 0x0, 0x0, 0x0, 0x0, 0x0, 0x90, 0x9, 0x0, 0x90, 0x0, 0x0, 0x1, 0x0, 0x0, 0x0, 0x8, 0x0, 0x0, 0x0, 0x0, 0x0, 0x90, 0x9, 0x0, 0x90, 0x0, 0x0, 0x1, 0x0, 0x0, 0x0, 0x8, 0x0, 0x0, 0x0, 0x0, 0x0, 0x90, 0x9, 0x0, 0x90, 0x0, 0x0, 0x1, 0x0, 0x0, 0x0, 0x8, 0x0, 0x0, 0x0, 0x0, 0x0, 0x90, 0x9, 0x0, 0x90, 0x0, 0x0, 0x1, 0x0, 0x0, 0x0, 0x8, 0x0, 0x0, 0x0, 0x0, 0x0, 0x90, 0x9, 0x0, 0x90, 0x0, 0x0, 0x1, 0x0, 0x0, 0x2, 0x28, 0x0, 0x88, 0x0, 0x0, 0x0, 0x90, 0x9, 0x0, 0x90, 0x8, 0x80, 0x1, 0x0, 0x0, 0x40, 0x48, 0x10, 0x10, 0x0, 0x0, 0x0, 0x90, 0x9, 0x0, 0x91, 0x1, 0x0, 0x1, 0x0, 0x0, 0x85, 0x48, 0x21, 0x50, 0x0, 0x0, 0x0, 0x90, 0x9, 0x0, 0x92, 0x15, 0x0, 0x1, 0x0, 0x1, 0x4, 0x88, 0x41, 0x22, 0x0, 0x0, 0x0, 0x90, 0x9, 0x0, 0x94, 0x12, 0x20, 0x1, 0x0, 0x1, 0xea, 0x88, 0x7a, 0xa4, 0x0, 0x0, 0x0, 0x90, 0x9, 0x0, 0x97, 0xaa, 0x40, 0x1, 0x0, 0xa, 0x14, 0xa8, 0x85, 0x24, 0x0, 0x0, 0x0, 0x90, 0x9, 0x0, 0x98, 0x52, 0x40, 0x1, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x1, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0x95, 0x55, 0x52, 0xaa, 0xaa, 0xaa, 0xac, 0xaa, 0xaa, 0x95, 0x55, 0x53, 0x2a, 0xaa, 0xa5, 0x55, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x1, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x1, 0x4, 0x4, 0x10, 0x80, 0xa0, 0x8, 0x8, 0x20, 0x20, 0x84, 0x4, 0x40, 0x8, 0x8, 0x21, 0x1, 0x81, 0x1, 0x0, 0x20, 0x8, 0x2, 0x4, 0x8, 0x8, 0x1, 0x1, 0x11, 0x2, 0x2, 0x0, 0x41, };

    const unsigned char KM1[]={0xff, 0xff, 0xf8, 0x3f, 0xe0, 0xf, 0xe0, 0xf, 0xc0, 0x17, 0xc0, 0x17, 0xc2, 0x17, 0xc1, 0x7, 0xc1, 0x7, 0xe2, 0x17, 0xfc, 0x7, 0x90, 0xf, 0x88, 0x1f, 0x8f, 0xe3, 0xff, 0xc3, 0xff, 0xff, };
    const unsigned char KM1N[]={0x7, 0xc0, 0x1f, 0xf0, 0x3f, 0xf8, 0x3f, 0xf8, 0x7f, 0xfc, 0x7f, 0xfc, 0x7f, 0xfc, 0x7f, 0xfc, 0x7f, 0xfc, 0x7f, 0xfc, 0xff, 0xfc, 0xff, 0xf8, 0xff, 0xfc, 0xff, 0xfe, 0x70, 0x7e, 0x0, 0x3c, };
    const unsigned char KM2[]={0xff, 0xff, 0xf8, 0x1f, 0xe0, 0xf, 0xc0, 0xf, 0xc0, 0x57, 0x80, 0x57, 0x80, 0x55, 0x80, 0x5, 0x88, 0x5, 0xc8, 0x25, 0xf8, 0x7, 0xfc, 0xf, 0xf3, 0xff, 0xf8, 0x5f, 0xff, 0xff, 0xff, 0xff, };
    const unsigned char KM2N[]={0x7, 0xe0, 0x1f, 0xf0, 0x3f, 0xf8, 0x7f, 0xf8, 0x7f, 0xfc, 0xff, 0xfe, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0x7f, 0xff, 0x3f, 0xfe, 0x1f, 0xf8, 0x1f, 0xf0, 0xf, 0xf0, 0x7, 0xe0, 0x0, 0x0, };
    const unsigned char KM3[]={0xff, 0xff, 0xf8, 0x3f, 0xe0, 0xf, 0xf0, 0xf, 0x80, 0xa5, 0x80, 0xa5, 0x80, 0xa5, 0x80, 0x5, 0xe0, 0x7, 0xe0, 0x47, 0xe0, 0xb, 0xd0, 0xb, 0xcc, 0x33, 0xe3, 0xc7, 0xf1, 0xff, 0xff, 0xff, };
    const unsigned char KM3N[]={0x7, 0xc0, 0x1f, 0xf0, 0x3f, 0xf8, 0x7f, 0xfe, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0x7f, 0xfe, 0x3f, 0xfc, 0x7f, 0xfe, 0x7f, 0xfe, 0x7f, 0xfe, 0x3f, 0xfc, 0x1f, 0x38, 0xe, 0x0, };

    const unsigned char Tableau[]={0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0x80, 0x0, 0x0, 0x0, 0x0, 0x0, 0x7, 0xa0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x17, 0x80, 0x77, 0x57, 0x70, 0x75, 0x70, 0x7, 0x80, 0x25, 0x54, 0x52, 0x45, 0x40, 0x7, 0x80, 0x25, 0x56, 0x50, 0x62, 0x60, 0x7, 0x80, 0x25, 0x54, 0x62, 0x45, 0x40, 0x7, 0x80, 0x67, 0x77, 0x50, 0x75, 0x70, 0x7, 0x80, 0x0, 0x0, 0x0, 0x0, 0x0, 0x7, 0x80, 0x0, 0x0, 0x0, 0x0, 0x0, 0x7, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xf8, 0x0, 0x0, 0x0, 0x0, 0x0, 0x7f, 0xfa, 0x0, 0x0, 0x0, 0x0, 0x1, 0x7f, 0xf8, 0x0, 0xe, 0xab, 0x80, 0x0, 0x7f, 0xf8, 0x0, 0x48, 0xa9, 0x10, 0x0, 0x7f, 0xf8, 0x0, 0xc, 0x49, 0x0, 0x0, 0x7f, 0xf8, 0x0, 0x48, 0xa9, 0x10, 0x0, 0x7f, 0xf8, 0x0, 0xe, 0xa9, 0x0, 0x0, 0x7f, 0xf8, 0x0, 0x0, 0x0, 0x0, 0x0, 0x7f, 0xf8, 0x0, 0x0, 0x0, 0x0, 0x0, 0x7f, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, };
    const unsigned char TableauN[]={0x2, 0x0, 0x0, 0x0, 0x0, 0x1, 0x3, 0x2, 0x0, 0x0, 0x0, 0x0, 0x1, 0x3, 0x2, 0x0, 0x0, 0x0, 0x0, 0x1, 0x3, 0x2, 0x0, 0x0, 0x0, 0x0, 0x1, 0x3, 0x2, 0x0, 0x0, 0x0, 0x0, 0x1, 0x3, 0x2, 0x0, 0x0, 0x0, 0x0, 0x1, 0x3, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0x0, 0x2, 0x0, 0x0, 0x1, 0x0, 0x3, 0x0, 0x2, 0x0, 0x0, 0x1, 0x0, 0x3, 0x0, 0x2, 0x0, 0x0, 0x1, 0x0, 0x3, 0x0, 0x2, 0x0, 0x0, 0x1, 0x0, 0x3, 0xf, 0xff, 0xff, 0xff, 0xff, 0xff, 0xc3, 0xf, 0xff, 0xff, 0xff, 0xff, 0xff, 0xc3, 0xf, 0xff, 0xff, 0xff, 0xff, 0xff, 0xc3, 0xf, 0xff, 0xff, 0xff, 0xff, 0xff, 0xc3, 0xf, 0xff, 0xff, 0xff, 0xff, 0xff, 0xc3, 0xf, 0xff, 0xff, 0xff, 0xff, 0xff, 0xc3, 0xf, 0xff, 0xff, 0xff, 0xff, 0xff, 0xc3, 0xf, 0xff, 0xff, 0xff, 0xff, 0xff, 0xc3, 0xf, 0xff, 0xff, 0xff, 0xff, 0xff, 0xc3, 0xf, 0xff, 0xff, 0xff, 0xff, 0xff, 0xc3, 0xf, 0xff, 0xff, 0xff, 0xff, 0xff, 0xc3, };

    const unsigned char Titre[]={0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x7, 0x0, 0x40, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x7, 0x4c, 0x40, 0xc, 0x0, 0x63, 0x8e, 0x0, 0x0, 0x0, 0xc, 0x0, 0x0, 0x17, 0x4c, 0x0, 0xc, 0x0, 0x66, 0xcd, 0x0, 0x0, 0x0, 0xc, 0x0, 0x0, 0x17, 0x59, 0xc2, 0x4f, 0x12, 0x66, 0xd, 0x92, 0x38, 0xe3, 0xec, 0xe, 0x78, 0xf7, 0x58, 0x42, 0xcd, 0x92, 0x2, 0xd, 0x96, 0x6c, 0x12, 0xac, 0x3, 0x6c, 0x97, 0x58, 0x42, 0xd, 0x92, 0x1, 0x8d, 0x90, 0x7c, 0xf2, 0xac, 0xf, 0x6c, 0x97, 0x58, 0x42, 0xd, 0x92, 0x0, 0xcd, 0x90, 0x61, 0x92, 0xac, 0x13, 0x6c, 0x97, 0x4c, 0x42, 0xd, 0x92, 0x6, 0xcd, 0x10, 0x61, 0x92, 0xac, 0x13, 0x6c, 0x97, 0x4d, 0xf2, 0xf, 0x1e, 0x3, 0x8e, 0x10, 0x38, 0xf2, 0x2f, 0x8f, 0x6c, 0xf7, 0x0, 0x0, 0x0, 0x6, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x7, 0x0, 0x0, 0x0, 0x38, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x7, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x7, };

    Sprite S_Kirby_Cour_1(KM1 , KM1N ,16 ,16);
    Sprite S_Kirby_Cour_2(KM2 , KM2N ,16 ,16);
    Sprite S_Kirby_Cour_3(KM3 , KM3N ,16 ,16);
    Sprite S_Kirby_Cour[]={ S_Kirby_Cour_1 , S_Kirby_Cour_2 , S_Kirby_Cour_3};
    Animation Kirby(S_Kirby_Cour , 3 );

    Sprite S_Tableau(Tableau , TableauN , 54 , 32 );
    Animation A_Tableau(S_Tableau);

    int x = 127;


    ML_clear_vram();

    ML_bmp_or(Titre , 13 , 25 , 101 , 13 );

    PrintMini(90,50,"By Fife86" , 0);

    ML_display_vram();

    Sleep(1500);

    int end = 0;

    while(1)
    {


        ML_clear_vram();
        input_update();
        //*******************///


        ML_bmp_or_cl(Menu , x , 0, 127 , 63);
        ML_bmp_or_cl(Menu , x - 127 , 0, 127 , 63);

        A_Tableau.DrawAnim(36,0 , 0);

        if(end == 0)
        {
            x--;
            if(x < 0 ) x = 127;

            Kirby.DrawAnim(16 , 38 , 0);

            if(input_press(K_EXE))end = 1;

        }
        else
        {
            end = end + 2;

            Kirby.DrawAnim(16 + end , 38 ,0);

            if(end > 111)
            {

                switch(SelectLevel())
                {
                    case 1:
                        Niveau1();
                    break;
                    default:

                    break;
                }

                Sleep(200);
                input_update();
                end = 0;
            }
        }

            if(input_press(K_EXIT))return 1;




        Sleep(30);

        //*******************//
        ML_display_vram();
    }
}


extern "C"
{
int AddIn_main(int isAppli, unsigned short OptionNum)
{
    Menu();
    return 1;
}


#pragma section _BR_Size
unsigned long BR_Size;
#pragma section


#pragma section _TOP

int InitializeSystem(int isAppli, unsigned short OptionNum)
{
    return INIT_ADDIN_APPLICATION(isAppli, OptionNum);
}

#pragma section
}

